org.apache.lucene.index

## Class FilterIndexReader

- java.lang.Object
- - org.apache.lucene.index.IndexReader
  - - org.apache.lucene.index.FilterIndexReader

- All Implemented Interfaces:
    java.lang.Cloneable

      public class FilterIndexReader
      extends IndexReader

  A `FilterIndexReader` contains another IndexReader, which it uses as its basic source of data, possibly transforming the data along the way or providing additional functionality. The class `FilterIndexReader` itself simply implements all abstract methods of `IndexReader` with versions that pass all requests to the contained index reader. Subclasses of `FilterIndexReader` may further override some of these methods and may also provide additional methods and fields.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `FilterIndexReader.FilterTermDocs` Base class for filtering `TermDocs` implementations.
    `static class` | `FilterIndexReader.FilterTermEnum` Base class for filtering `TermEnum` implementations.
    `static class` | `FilterIndexReader.FilterTermPositions` Base class for filtering `TermPositions` implementations.

    - ### Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader

      `IndexReader.FieldOption`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected IndexReader` | `in`

    - ### Fields inherited from class org.apache.lucene.index.IndexReader

      `hasChanges`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FilterIndexReader(IndexReader in)` Construct a FilterIndexReader based on the specified base reader.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `Directory` | `directory()` Returns the directory associated with this index.
    `int` | `docFreq(Term t)` Returns the number of documents containing the term `t`.
    `protected void` | `doClose()` Implements close.
    `protected void` | `doCommit()` Deprecated.
    `protected void` | `doCommit(java.util.Map commitUserData)` Implements commit.
    `Document` | `document(int n, FieldSelector fieldSelector)` Get the `Document` at the `n` th position.
    `protected void` | `doDelete(int n)` Implements deletion of the document numbered `docNum`.
    `protected void` | `doSetNorm(int d, java.lang.String f, byte b)` Implements setNorm in subclass.
    `protected void` | `doUndeleteAll()` Implements actual undeleteAll() in subclass.
    `java.lang.Object` | `getDeletesCacheKey()` If the subclass of FilteredIndexReader modifies the deleted docs, you must override this method to provide a different key
    `java.lang.Object` | `getFieldCacheKey()` If the subclass of FilteredIndexReader modifies the contents of the FieldCache, you must override this method to provide a different key
    `java.util.Collection` | `getFieldNames(IndexReader.FieldOption fieldNames)` Get a list of unique field names that exist in this index and have the specified field option information.
    `IndexReader[]` | `getSequentialSubReaders()` Expert: returns the sequential sub readers that this reader is logically composed of.
    `TermFreqVector` | `getTermFreqVector(int docNumber, java.lang.String field)` Return a term frequency vector for the specified document and field.
    `void` | `getTermFreqVector(int docNumber, java.lang.String field, TermVectorMapper mapper)` Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.
    `void` | `getTermFreqVector(int docNumber, TermVectorMapper mapper)` Map all the term vectors for all fields in a Document
    `TermFreqVector[]` | `getTermFreqVectors(int docNumber)` Return an array of term frequency vectors for the specified document.
    `long` | `getVersion()` Version number when this IndexReader was opened.
    `boolean` | `hasDeletions()` Returns true if any documents have been deleted
    `boolean` | `hasNorms(java.lang.String field)` Returns true if there are norms stored for this field.
    `boolean` | `isCurrent()` Check whether any new changes have occurred to the index since this reader was opened.
    `boolean` | `isDeleted(int n)` Returns true if document n has been deleted
    `boolean` | `isOptimized()` Checks is the index is optimized (if it has a single segment and no deletions).
    `int` | `maxDoc()` Returns one greater than the largest possible document number.
    `byte[]` | `norms(java.lang.String f)` Returns the byte-encoded normalization factor for the named field of every document.
    `void` | `norms(java.lang.String f, byte[] bytes, int offset)` Reads the byte-encoded normalization factor for the named field of every document.
    `int` | `numDocs()` Returns the number of documents in this index.
    `TermDocs` | `termDocs()` Returns an unpositioned `TermDocs` enumerator.
    `TermDocs` | `termDocs(Term term)` Returns an enumeration of all the documents which contain `term`.
    `TermPositions` | `termPositions()` Returns an unpositioned `TermPositions` enumerator.
    `TermEnum` | `terms()` Returns an enumeration of all the terms in the index.
    `TermEnum` | `terms(Term t)` Returns an enumeration of all terms starting at a given term.

    - ### Methods inherited from class org.apache.lucene.index.IndexReader

      `acquireWriteLock, clone, clone, close, commit, commit, decRef, deleteDocument, deleteDocuments, document, ensureOpen, flush, flush, getCommitUserData, getCommitUserData, getCurrentVersion, getCurrentVersion, getCurrentVersion, getDisableFakeNorms, getIndexCommit, getRefCount, getTermInfosIndexDivisor, getUniqueTermCount, incRef, indexExists, indexExists, indexExists, isLocked, isLocked, lastModified, lastModified, lastModified, listCommits, main, numDeletedDocs, open, open, open, open, open, open, open, open, open, open, open, open, open, open, reopen, reopen, reopen, setDisableFakeNorms, setNorm, setNorm, setTermInfosIndexDivisor, termPositions, undeleteAll, unlock`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### in

          protected IndexReader in

  - ### Constructor Detail

    - #### FilterIndexReader

          public FilterIndexReader(IndexReader in)

      Construct a FilterIndexReader based on the specified base reader. Directory locking for delete, undeleteAll, and setNorm operations is left to the base reader.

      Note that base reader is closed if this FilterIndexReader is closed.

      Parameters:
        `in` - specified base reader.

  - ### Method Detail

    - #### directory

          public Directory directory()

      Description copied from class: `IndexReader`
      Returns the directory associated with this index. The Default implementation returns the directory specified by subclasses when delegating to the IndexReader(Directory) constructor, or throws an UnsupportedOperationException if one was not specified.
      Overrides:
        `directory` in class `IndexReader`

    - #### getTermFreqVectors

          public TermFreqVector[] getTermFreqVectors(int docNumber)
                                              throws java.io.IOException

      Description copied from class: `IndexReader`
      Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector contains terms and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null. The term vectors that are returned may either be of type `TermFreqVector` or of type `TermPositionVector` if positions or offsets have been stored.
      Specified by:
        `getTermFreqVectors` in class `IndexReader`
      Parameters:
        `docNumber` - document for which term frequency vectors are returned
      Returns:
        array of term frequency vectors. May be null if no term vectors have been stored for the specified document.
      Throws:
        `java.io.IOException` - if index cannot be accessed
      See Also:
        `Field.TermVector`

    - #### getTermFreqVector

          public TermFreqVector getTermFreqVector(int docNumber,
                                                  java.lang.String field)
                                           throws java.io.IOException

      Description copied from class: `IndexReader`
      Return a term frequency vector for the specified document and field. The returned vector contains terms and frequencies for the terms in the specified field of this document, if the field had the storeTermVector flag set. If termvectors had been stored with positions or offsets, a `TermPositionVector` is returned.
      Specified by:
        `getTermFreqVector` in class `IndexReader`
      Parameters:
        `docNumber` - document for which the term frequency vector is returned
        `field` - field for which the term frequency vector is returned.
      Returns:
        term frequency vector May be null if field does not exist in the specified document or term vector was not stored.
      Throws:
        `java.io.IOException` - if index cannot be accessed
      See Also:
        `Field.TermVector`

    - #### getTermFreqVector

          public void getTermFreqVector(int docNumber,
                                        java.lang.String field,
                                        TermVectorMapper mapper)
                                 throws java.io.IOException

      Description copied from class: `IndexReader`
      Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.
      Specified by:
        `getTermFreqVector` in class `IndexReader`
      Parameters:
        `docNumber` - The number of the document to load the vector for
        `field` - The name of the field to load
        `mapper` - The `TermVectorMapper` to process the vector. Must not be null
      Throws:
        `java.io.IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

    - #### getTermFreqVector

          public void getTermFreqVector(int docNumber,
                                        TermVectorMapper mapper)
                                 throws java.io.IOException

      Description copied from class: `IndexReader`
      Map all the term vectors for all fields in a Document
      Specified by:
        `getTermFreqVector` in class `IndexReader`
      Parameters:
        `docNumber` - The number of the document to load the vector for
        `mapper` - The `TermVectorMapper` to process the vector. Must not be null
      Throws:
        `java.io.IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

    - #### numDocs

          public int numDocs()

      Description copied from class: `IndexReader`
      Returns the number of documents in this index.
      Specified by:
        `numDocs` in class `IndexReader`

    - #### maxDoc

          public int maxDoc()

      Description copied from class: `IndexReader`
      Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.
      Specified by:
        `maxDoc` in class `IndexReader`

    - #### document

          public Document document(int n,
                                   FieldSelector fieldSelector)
                            throws CorruptIndexException,
                                   java.io.IOException

      Description copied from class: `IndexReader`
      Get the `Document` at the `n` th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If this Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.

      NOTE: for performance reasons, this method does not check if the requested document is deleted, and therefore asking for a deleted document may yield unspecified results. Usually this is not required, however you can call `IndexReader.isDeleted(int)` with the requested document ID to verify the document is not deleted.

      Specified by:
        `document` in class `IndexReader`
      Parameters:
        `n` - Get the document at the `n`th position
        `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
      Returns:
        The stored fields of the `Document` at the nth position
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error
      See Also:
        `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

    - #### isDeleted

          public boolean isDeleted(int n)

      Description copied from class: `IndexReader`
      Returns true if document n has been deleted
      Specified by:
        `isDeleted` in class `IndexReader`

    - #### hasDeletions

          public boolean hasDeletions()

      Description copied from class: `IndexReader`
      Returns true if any documents have been deleted
      Specified by:
        `hasDeletions` in class `IndexReader`

    - #### doUndeleteAll

          protected void doUndeleteAll()
                                throws CorruptIndexException,
                                       java.io.IOException

      Description copied from class: `IndexReader`
      Implements actual undeleteAll() in subclass.
      Specified by:
        `doUndeleteAll` in class `IndexReader`
      Throws:
        `CorruptIndexException`
        `java.io.IOException`

    - #### hasNorms

          public boolean hasNorms(java.lang.String field)
                           throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns true if there are norms stored for this field.
      Overrides:
        `hasNorms` in class `IndexReader`
      Throws:
        `java.io.IOException`

    - #### norms

          public byte[] norms(java.lang.String f)
                       throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.
      Specified by:
        `norms` in class `IndexReader`
      Throws:
        `java.io.IOException`
      See Also:
        `AbstractField.setBoost(float)`

    - #### norms

          public void norms(java.lang.String f,
                            byte[] bytes,
                            int offset)
                     throws java.io.IOException

      Description copied from class: `IndexReader`
      Reads the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.
      Specified by:
        `norms` in class `IndexReader`
      Throws:
        `java.io.IOException`
      See Also:
        `AbstractField.setBoost(float)`

    - #### doSetNorm

          protected void doSetNorm(int d,
                                   java.lang.String f,
                                   byte b)
                            throws CorruptIndexException,
                                   java.io.IOException

      Description copied from class: `IndexReader`
      Implements setNorm in subclass.
      Specified by:
        `doSetNorm` in class `IndexReader`
      Throws:
        `CorruptIndexException`
        `java.io.IOException`

    - #### terms

          public TermEnum terms()
                         throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns an enumeration of all the terms in the index. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration. Note that after calling terms(), `TermEnum.next()` must be called on the resulting enumeration before calling other methods such as `TermEnum.term()`.
      Specified by:
        `terms` in class `IndexReader`
      Throws:
        `java.io.IOException` - if there is a low-level IO error

    - #### terms

          public TermEnum terms(Term t)
                         throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns an enumeration of all terms starting at a given term. If the given term does not exist, the enumeration is positioned at the first term greater than the supplied term. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration.
      Specified by:
        `terms` in class `IndexReader`
      Throws:
        `java.io.IOException` - if there is a low-level IO error

    - #### docFreq

          public int docFreq(Term t)
                      throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns the number of documents containing the term `t`.
      Specified by:
        `docFreq` in class `IndexReader`
      Throws:
        `java.io.IOException` - if there is a low-level IO error

    - #### termDocs

          public TermDocs termDocs()
                            throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns an unpositioned `TermDocs` enumerator.
      Specified by:
        `termDocs` in class `IndexReader`
      Throws:
        `java.io.IOException` - if there is a low-level IO error

    - #### termDocs

          public TermDocs termDocs(Term term)
                            throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns an enumeration of all the documents which contain `term`. For each document, the document number, the frequency of the term in that document is also provided, for use in search scoring. If term is null, then all non-deleted docs are returned with freq=1. Thus, this method implements the mapping:

      Term => <docNum, freq>*

      The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration.

      Overrides:
        `termDocs` in class `IndexReader`
      Throws:
        `java.io.IOException` - if there is a low-level IO error

    - #### termPositions

          public TermPositions termPositions()
                                      throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns an unpositioned `TermPositions` enumerator.
      Specified by:
        `termPositions` in class `IndexReader`
      Throws:
        `java.io.IOException` - if there is a low-level IO error

    - #### doDelete

          protected void doDelete(int n)
                           throws CorruptIndexException,
                                  java.io.IOException

      Description copied from class: `IndexReader`
      Implements deletion of the document numbered `docNum`. Applications should call `IndexReader.deleteDocument(int)` or `IndexReader.deleteDocuments(Term)`.
      Specified by:
        `doDelete` in class `IndexReader`
      Throws:
        `CorruptIndexException`
        `java.io.IOException`

    - #### doCommit

          protected void doCommit()
                           throws java.io.IOException

      Deprecated.
      Description copied from class: `IndexReader`
      Implements commit.
      Specified by:
        `doCommit` in class `IndexReader`
      Throws:
        `java.io.IOException`

    - #### doCommit

          protected void doCommit(java.util.Map commitUserData)
                           throws java.io.IOException

      Description copied from class: `IndexReader`
      Implements commit. NOTE: subclasses should override this. In 3.0 this will become an abstract method.
      Throws:
        `java.io.IOException`

    - #### doClose

          protected void doClose()
                          throws java.io.IOException

      Description copied from class: `IndexReader`
      Implements close.
      Specified by:
        `doClose` in class `IndexReader`
      Throws:
        `java.io.IOException`

    - #### getFieldNames

          public java.util.Collection getFieldNames(IndexReader.FieldOption fieldNames)

      Description copied from class: `IndexReader`
      Get a list of unique field names that exist in this index and have the specified field option information.
      Specified by:
        `getFieldNames` in class `IndexReader`
      Parameters:
        `fieldNames` - specifies which field option should be available for the returned fields
      Returns:
        Collection of Strings indicating the names of the fields.
      See Also:
        `IndexReader.FieldOption`

    - #### getVersion

          public long getVersion()

      Description copied from class: `IndexReader`
      Version number when this IndexReader was opened. Not implemented in the IndexReader base class.

      If this reader is based on a Directory (ie, was created by calling `IndexReader.open(java.lang.String)`, or `IndexReader.reopen()` on a reader based on a Directory), then this method returns the version recorded in the commit that the reader opened. This version is advanced every time `IndexWriter.commit(long)` is called.

      If instead this reader is a near real-time reader (ie, obtained by a call to `IndexWriter.getReader()`, or by calling `IndexReader.reopen()` on a near real-time reader), then this method returns the version of the last commit done by the writer. Note that even as further changes are made with the writer, the version will not changed until a commit is completed. Thus, you should not rely on this method to determine when a near real-time reader should be opened. Use `IndexReader.isCurrent()` instead.

      Overrides:
        `getVersion` in class `IndexReader`

    - #### isCurrent

          public boolean isCurrent()
                            throws CorruptIndexException,
                                   java.io.IOException

      Description copied from class: `IndexReader`
      Check whether any new changes have occurred to the index since this reader was opened.

      If this reader is based on a Directory (ie, was created by calling `IndexReader.open(java.lang.String)`, or `IndexReader.reopen()` on a reader based on a Directory), then this method checks if any further commits (see `IndexWriter.commit(long)` have occurred in that directory).

      If instead this reader is a near real-time reader (ie, obtained by a call to `IndexWriter.getReader()`, or by calling `IndexReader.reopen()` on a near real-time reader), then this method checks if either a new commmit has occurred, or any new uncommitted changes have taken place via the writer. Note that even if the writer has only performed merging, this method will still return false.

      In any event, if this returns false, you should call `IndexReader.reopen()` to get a new reader that sees the changes.

      Overrides:
        `isCurrent` in class `IndexReader`
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error

    - #### isOptimized

          public boolean isOptimized()

      Description copied from class: `IndexReader`
      Checks is the index is optimized (if it has a single segment and no deletions). Not implemented in the IndexReader base class.
      Overrides:
        `isOptimized` in class `IndexReader`
      Returns:
        `true` if the index is optimized; `false` otherwise

    - #### getSequentialSubReaders

          public IndexReader[] getSequentialSubReaders()

      Description copied from class: `IndexReader`
      Expert: returns the sequential sub readers that this reader is logically composed of. For example, IndexSearcher uses this API to drive searching by one sub reader at a time. If this reader is not composed of sequential child readers, it should return null. If this method returns an empty array, that means this reader is a null reader (for example a MultiReader that has no sub readers).

      NOTE: You should not try using sub-readers returned by this method to make any changes (setNorm, deleteDocument, etc.). While this might succeed for one composite reader (like MultiReader), it will most likely lead to index corruption for other readers (like DirectoryReader obtained through `IndexReader.open(java.lang.String)`. Use the parent reader directly.

      Overrides:
        `getSequentialSubReaders` in class `IndexReader`

    - #### getFieldCacheKey

          public java.lang.Object getFieldCacheKey()

      If the subclass of FilteredIndexReader modifies the contents of the FieldCache, you must override this method to provide a different key
      Overrides:
        `getFieldCacheKey` in class `IndexReader`

    - #### getDeletesCacheKey

          public java.lang.Object getDeletesCacheKey()

      If the subclass of FilteredIndexReader modifies the deleted docs, you must override this method to provide a different key
      Overrides:
        `getDeletesCacheKey` in class `IndexReader`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.